
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef QUEST_BEHAVIOR_H
#define QUEST_BEHAVIOR_H

#include "types.h"

#define NO_BEHAVIOR (-1)

extern char *behavior_library_path;
extern GList *behavior_libraries;

extern GHashTable *behavior_func_names;

/* array of pointers to functions that take a 
 * Map* and a Mob* as their arguments 
 */
extern int (**behavior_funcs)(Map* map,Mob *self);


void add_behavior_library(char *filename);
int load_behavior(char *name);

#endif QUEST_BEHAVIOR_H
