
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#include "behavior_funcs.h"

int hello_world(Map *map,Mob *mob) {

  fprintf(stdout,"%s sais hello world!\n",
	  ((mob == NULL) || (mob->data[MOB_DATA_NAME] == NULL)) ?
	  "A mysterious voice" : mob->data[MOB_DATA_NAME]);

  return 0;

}

int do_nothing(Map *map,Mob *mob) {
  return 0;
}

int player_behavior(Map *map,Mob *mob) {
  
  int 
    *brain = (int*)mob->data[MOB_DATA_BRAIN],
    *img   = (int*)mob->data[MOB_DATA_IMAGE];
  Uint32 now = SDL_GetTicks();

  if((brain[3] != -1) && (now < brain[3])) return 0;
  else {
    int  dx,dy;
    unsigned short
      diff  = ((((brain[0] & 0x0F0) >> 4) ^ (brain[0] & 0x00F)) |
	       (((brain[0] & 0xF00) >> 8) ^ (brain[0] & 0x00F))),
      up    = !GET_FLAG(brain[0],0) || !GET_FLAG(brain[0],8),
      right = !GET_FLAG(brain[0],1) || !GET_FLAG(brain[0],9),
      down  = !GET_FLAG(brain[0],2) || !GET_FLAG(brain[0],10),
      left  = !GET_FLAG(brain[0],3) || !GET_FLAG(brain[0],11),
      cnt = up + right + down + left;

    SET_FLAG(brain[0],8);
    SET_FLAG(brain[0],9);
    SET_FLAG(brain[0],10);
    SET_FLAG(brain[0],11);

    dx = right - left;
    dy = down - up;

    if(((dx != 0) || (dy != 0)) && (cnt < 3)) {

      brain[3] = now + 200;

      mob_move(mob,map,mob->x,mob->y,mob->x+dx,mob->y+dy);

      if(diff != 0) {
	int n = ((GET_FLAG(diff,0) && dy) ? 0 :
		 (GET_FLAG(diff,1) && dx) ? 2 :
		 (GET_FLAG(diff,2) && dy) ? 4 :
		 (GET_FLAG(diff,3) && dx) ? 6 : -1);
	
	if(n != -1) {
	  img[1] = img[1]%2 + n;
	} else if(cnt != 0) {
	  img[1] = ((up)    ? img[1]%2 + 0 :
		    (right) ? img[1]%2 + 2 : 
		    (down)  ? img[1]%2 + 4 :
		    (left)  ? img[1]%2 + 6 : img[1]);
	}
	
	/* copy old direction bits */
	brain[0] = ((brain[0] & 0x0F) << 4) | (brain[0] & 0x0F);
      }
      img[1] += (img[1] % 2) ? -1 : +1;    
    }
  }
  
  return 0;

}

int walk_test(Map *map,Mob *mob) {

  int i,j,
    *brain = (int*)mob->data[MOB_DATA_BRAIN],
    *img = (int*)mob->data[MOB_DATA_IMAGE];
  Uint32 now = SDL_GetTicks();

  if((brain[3] != -1) && (now < brain[3])) return;

  //fprintf(stdout,"*** move knight\n");

  brain[3] = now + 200;

  switch(brain[0]) {
  case 0:
    if(mob->y <= 5) {
      brain[0]++; 
    } else {
      img[1] = img[1]%2 + 0;
      brain[1] = 0;
      brain[2] = -1;
    } break;
  case 1:
    if(mob->x >= 8) {
      brain[0]++;   
    } else {
      img[1] = img[1]%2 + 2; 
      brain[1] = 1;
      brain[2] = 0;
    } break;
  case 2:
    if(mob->y >= 8) {
      brain[0]++;   
    } else {
      img[1] = img[1]%2 + 4; 
      brain[1] = 0;
      brain[2] = 1;
    } break;
  case 3:
    if(mob->x <= 5) {
      brain[0] = 0;
    } else {
      img[1] = img[1]%2 + 6; 
      brain[1] = -1;
      brain[2] = 0;
    } break;
  default: {
    //fprintf(stdout,"initializing %s's brain\n",
    //	    (char*)mob->data[MOB_DATA_NAME]);
    brain[0] = 0;
    brain[1] = 0;
    brain[2] = -1;
  } break;
  }

  /* walk up or down */
  mob_move(mob,map,mob->x,mob->y,mob->x+brain[1],mob->y+brain[2]);

  /* switch from left to right foot or back */
  img[1] += (img[1] % 2) ? -1 : +1;    

  return 0;

}

int walk_test2(Map *map,Mob *mob) {

  int i,j,
    *brain = (int*)mob->data[MOB_DATA_BRAIN],
    *img = (int*)mob->data[MOB_DATA_IMAGE];
  Uint32 now = SDL_GetTicks();

  if((brain[3] != -1) && (now < brain[3])) return;

  //fprintf(stdout,"*** move ogre\n");

  brain[3] = now + 400;

  switch(brain[0]) {
  case 0:
    if(mob->y <= 12) {
      brain[0]++; 
    } else {
      img[1] = img[1]%2 + 0;
      brain[1] = 0;
      brain[2] = -1;
    } break;
  case 1:
    if(mob->x >= 18) {
      brain[0]++;   
    } else {
      img[1] = img[1]%2 + 2; 
      brain[1] = 1;
      brain[2] = 0;
    } break;
  case 2:
    if(mob->y >= 18) {
      brain[0]++;   
    } else {
      img[1] = img[1]%2 + 4; 
      brain[1] = 0;
      brain[2] = 1;
    } break;
  case 3:
    if(mob->x <= 12) {
      brain[0] = 0;
    } else {
      img[1] = img[1]%2 + 6; 
      brain[1] = -1;
      brain[2] = 0;
    } break;
  default: {
    //fprintf(stdout,"initializing %s's brain\n",
    //    (char*)mob->data[MOB_DATA_NAME]);
    brain[0] = 0;
    brain[1] = 0;
    brain[2] = -1;
  } break;
  }

  /* walk up or down */
  mob_move(mob,map,mob->x,mob->y,mob->x+brain[1],mob->y+brain[2]);

  /* switch from left to right foot or back */
  img[1] += (img[1] % 2) ? -1 : +1;    

  return 0;

}
