
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef QUEST_DRAW_H
#define QUEST_DRAW_H

#include "types.h"
#include "image.h"
#include "map.h" /* for map_get_space() */

extern SDL_Surface *screen;
extern int screen_w,screen_h;
extern SDL_Rect *update;
extern int update_size;
extern Uint32 video_flags;

extern int viewport[4];
extern int tile_size;

extern GList *update_coords;


void draw_tile(SDL_Surface *image,int x,int y,int xo,int yo);
void draw_map(Map *map);

int inside_rect(int x1, int y1, int w, int h, int x2, int y2);

void space_frame_set(Space *space,SpaceData image,int x,int y,
		     int x_repeat,int y_repeat,int x_offset,int y_offset);
void mob_frame_set(Mob *mob,int x,int y,int x_repeat,int y_repeat,
		   int x_offset,int y_offset);

void set_viewport(int x,int y,int w,int h);

void add_update(int x,int y,int w,int h);
void clear_update();
void add_update_coord(int x,int y);
void add_update_rect(int x,int y,int w,int h);
void refresh_screen();

void map_2_screen_coords(SDL_Rect *rect,int x, int y,int w, int h);

#endif /* QUEST_DRAW_H */
