
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#include "interface.h"

Mob *player = NULL;

void move_test(Mob *mob) {
  
  int n;

  if(mob == NULL) return;
  (*behavior_funcs[n=load_behavior("walk_test")])(map,mob);

}

void parse_events(Uint32 until_time) {
  
  SDL_Event event;
  Uint32 start = SDL_GetTicks();
  while(SDL_GetTicks() - start < until_time) {
    while(SDL_PollEvent(&event)) {
      switch(event.type) {
        case SDL_KEYDOWN: {
	  switch(event.key.keysym.sym) {
	    case SDLK_UP:
	    case SDLK_KP8: {
	      if(player != NULL)
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],0);
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],8);
	    } break;
  	    case SDLK_RIGHT:
	    case SDLK_KP6: {
	      if(player != NULL)
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],1);
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],9);
	    } break;
	    case SDLK_DOWN:
	    case SDLK_KP2: {
	      if(player != NULL)
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],2);
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],10);
	    } break;
	    case SDLK_LEFT: 
	    case SDLK_KP4: { 
	      if(player != NULL)
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],3);
		CLR_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],11);
	    } break;
	    default: {
	      printf("%X was pressed\n",event.key.keysym.sym);
	    } break;
          } 
        } break;
        case SDL_KEYUP: {
	  switch(event.key.keysym.sym) {
	    case SDLK_UP:
	    case SDLK_KP8: {
	      if(player != NULL)
		SET_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],0);
	    } break;
  	    case SDLK_RIGHT:
	    case SDLK_KP6: {
	      if(player != NULL)
		SET_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],1);
	    } break;
	    case SDLK_DOWN:
	    case SDLK_KP2: {
	      if(player != NULL)
		SET_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],2);
	    } break;
	    case SDLK_LEFT: 
	    case SDLK_KP4: { 
	      if(player != NULL)
		SET_FLAG(((int*)player->data[MOB_DATA_BRAIN])[0],3);
	    } break;
  	    default: {
	      printf("%X was released\n",event.key.keysym.sym);
	    } break;
	  }
	} break;
        case SDL_MOUSEBUTTONDOWN: {
	  switch(event.button.button) {
	    case SDL_BUTTON_LEFT: {
	      int i = 0,
		x = event.button.x / tile_size,
		y = event.button.y / tile_size;
	      Space *space = map_get_space(map,x,y);
	      Mob *mob = NULL;
	      
	      printf("left click\n");
	      
	      while((mob = ((Mob**)space->data[SPACE_DATA_MOBS])[i++]) != NULL)
		fprintf(stdout,"That's %s\n",(char*)mob->data[MOB_DATA_NAME]);
	      
	      fprintf(stdout,"this space is %s\n",
		      (GET_FLAG(*space->flags,SPACE_FLAGS_SOLID)) ? 
		      "solid" : "not solid");

	    } break;
	    case SDL_BUTTON_MIDDLE: {
	      int x,y;
	      printf("middle click\n");
	      /* FIXME: add SDL_VideoModeOK() */
	      if(video_flags & SDL_FULLSCREEN) {
		video_flags = SDL_HWSURFACE;
		screen = SDL_SetVideoMode(screen_w, screen_h, 0 , video_flags);
	      } else {
		video_flags = SDL_HWSURFACE | SDL_FULLSCREEN;
		screen = SDL_SetVideoMode(screen_w, screen_h, 0, video_flags);
	      }
	      if(screen == NULL) {
		fprintf(stderr,"Couldn't set 640x480 video mode: %s\n",
			SDL_GetError());
		exit(1);
	      }
	      for(y=viewport[1];y<viewport[3];y++)
		for(x=viewport[0];x<viewport[2];x++)
		  add_update_coord(x,y);
	    } break;
  	    case SDL_BUTTON_RIGHT: {
	      printf("right click\n");
	      CLR_FLAG(*game_flags,GAME_FLAGS_RUNNING);
	    } break;
	  }
	} break;
        case SDL_MOUSEBUTTONUP: {
	  switch(event.button.button) {
	    case SDL_BUTTON_LEFT: {
	      printf("left released\n");
	    } break;
	    case SDL_BUTTON_MIDDLE: {
	      printf("middle released\n");
	    } break;
	    case SDL_BUTTON_RIGHT: {
	      printf("right released\n");
	    } break;
	  }
	} break;
        case SDL_QUIT: {
	  CLR_FLAG(*game_flags,GAME_FLAGS_RUNNING);
	} break;
      }
    }
  }
}
