
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#include <signal.h> /* to restore the core dump */

/* basically include everything */
#include "map.h"
#include "image.h"
#include "draw.h"
#include "mob.h"
#include "behavior.h"
#include "turn.h"
#include "interface.h"

/* a temporary function, just like map_generate(), it will be removed
 * the path resolving for function libraries, image libraries, 
 * data files, savegames, etc. is done.
 */
void init_behavior_library(char *libdir,char *lib) {

  behavior_library_path = g_strdup(libdir);
  add_behavior_library(lib);

}


int main(int argc,char *argv[]) {    

  if(SDL_Init(SDL_INIT_VIDEO) < 0) { 
    printf("Could not initialize SDL: %s.\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);
  signal(SIGSEGV, SIG_DFL); /* turn our loved core dump on again */

  screen = SDL_SetVideoMode(screen_w, screen_h, 0, video_flags=SDL_SWSURFACE);
  if(screen == NULL) {
    fprintf(stderr,"Couldn't set video mode: %s\n",SDL_GetError());
    exit(1);
  }

  /* run a test game */
  init_behavior_library(".","behavior");
  map = map_new();
  map_generate(map);
  game_loop();

  return(0);

}

