
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef QUEST_MAP_H
#define QUEST_MAP_H

#include "types.h"
#include "behavior.h"  /* for map_generate() */
#include "draw.h"      /* for tile_size */
#include "mob.h"       /* for mob_new() */
#include "interface.h" /* for player */

extern Map *map;

Map *map_new(void);
void map_destroy(Map **map);

/* functions to add space to the map,
 * for functions to add mob's to spaces, see mob.h
 */
void map_add_space(Map *map,Space *space);
void map_remove_space(Map *map,Space *space);
void map_remove_space_xy(Map *map,int x,int y);
guint map_remove_all_spaces(Map *map);
Space *map_get_space(Map *map,int x,int y);

gpointer xy_to_key(int x, int y);
gpointer space_to_key(Space *space);
gboolean space_remove_func(gpointer key,gpointer value, gpointer data);

void map_generate(Map *map);

Space *space_new(int x, int y);
void space_destroy(Space **space);


#endif /* QUEST_MAP_H */

