
/* Copyright (C) 2001 Willem Robert van Hage
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, you can get it from http://www.fsf.org
 * or write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef QUEST_MOB_H
#define QUEST_MOB_H

#include "types.h"
#include "draw.h" /* for tile_size */
#include "turn.h" /* for the list of mobs */

Mob *mob_new(char *name,int x,int y);
void mob_destroy(Mob **mob);

Mob *mob_move(Mob *mob,Map *map,int x1, int y1,int x2, int y2);
Mob *space_mob_move(Mob *mob,Space *from,Space *to);
void space_mob_add(Mob *mob,Space *space);
void space_mob_remove(Mob *mob,Space *space);

void mob_destroy_gfunc(gpointer data,gpointer user_data);

#endif /* QUEST_MOB_H */

